// THE HOVGAARD KLAN
// PROJECT: HOVTEXT
//---------------------------------------------------------------------------
// FILE......... : clipform.cpp
// DESCRIPTION.. : This is the form that does all the real work:
//						 It manages the tray-icons, contains the context-menu
//						 and does everything concerning the clipboard.
//						 The form itself is never shown.
// CHANGELOG.... :
//
//---------------------------------------------------------------------------

#ifndef ClipFormH
#define ClipFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Menus.hpp>
#include <ExtCtrls.hpp>
#include <Graphics.hpp>
#include <AppEvnts.hpp>
#include "lang.h"
//---------------------------------------------------------------------------

#define WM_TRAY_ICON_MESSAGE (WM_USER+1997)
//---------------------------------------------------------------------------
#define WM_TRAY_ICON_ID (9)


class TClipForm1 : public TForm, public TLangChangeNotify
{
__published:	// IDE-managed Components
  TPopupMenu *PopupMenu1;
  TMenuItem *Active1;
  TMenuItem *Exit1;
  TImage *ImageInactive;
  TImage *ImageActive;
  TMenuItem *About1;
  TMenuItem *Options1;
  TImage *ImageHotkey;
  TImage *AltImageInactive;
  TImage *AltImageActive;
  TImage *AltImageHotkey;
  TTimer *SetupTimer;
  void __fastcall Exit1Click(TObject *Sender);
  void __fastcall Active1Click(TObject *Sender);
  void __fastcall About1Click(TObject *Sender);
  void __fastcall Options1Click(TObject *Sender);
  void __fastcall SetupTimerTimer(TObject *Sender);
public:		// User declarations
  __fastcall TClipForm1(TComponent* Owner);
  __fastcall ~TClipForm1();
  void __fastcall ChangeIcons(short set=0);
  virtual void LangChange();

protected:
#pragma option push
#pragma option -w-inl
	 BEGIN_MESSAGE_MAP
		MESSAGE_HANDLER(WM_TRAY_ICON_MESSAGE,TMessage,TrayIcon_HandleMessage)
		MESSAGE_HANDLER(WM_HOTKEY,TMessage,WMHotKey)
		MESSAGE_HANDLER( WM_CHANGECBCHAIN, TWMChangeCBChain, WMChangeCBChain )
		MESSAGE_HANDLER( WM_DRAWCLIPBOARD, TWMDrawClipboard, WMDrawClipboard )
	 END_MESSAGE_MAP(TForm)
#pragma option pop

private:	// User declarations
  void TrayIcon_Create (const char *tipText,HICON hIcon);
  void TrayIcon_Delete(void);
  void TrayIcon_HandleMessage(TMessage &Message);
  void TrayIcon_ModifyTip(const char *tipText);
  void TrayIcon_ModifyIcon(HICON hIcon);

  bool ConvertOnCopy, IgnoreNextClipMessage;
  HWND m_hWndClipChain;
  void __fastcall WMChangeCBChain( TWMChangeCBChain& Message );
  void __fastcall WMDrawClipboard( TWMDrawClipboard& Message );

  char *ConvertedClipboard();
  bool __fastcall ConvertClip();
  void __fastcall SetActive(bool active);
  void __fastcall SetHotKey();
  void __fastcall UnsetHotKey();
  void __fastcall WMHotKey(TMessage &Message);
  bool HotKeySet;
  bool StripWS, StripCR,  OnlyCopyLinks;
  UINT CF_HTML;
};
//---------------------------------------------------------------------------
extern PACKAGE TClipForm1 *ClipForm1;
//---------------------------------------------------------------------------
#endif